Index: DataLoader/test/utest_abs_reader.py
===================================================================
--- DataLoader/test/utest_abs_reader.py	(revision adbb82177d68601371d58fccf5518ea1b52af88e)
+++ DataLoader/test/utest_abs_reader.py	(revision afab469f5d1e0cc0a7cfc1b1357f0b9d2fd644b1)
@@ -108,13 +108,13 @@
         
         self.assertEqual(self.data.detector[0].beam_center_unit, 'mm')
-        center_x = 68.76*5.0
-        center_y = 62.47*5.0
+        center_x = (68.76-1)*5.0
+        center_y = (62.47-1)*5.0
         self.assertEqual(self.data.detector[0].beam_center.x, center_x)
         self.assertEqual(self.data.detector[0].beam_center.y, center_y)
         
         self.assertEqual(self.data.I_unit, '1/cm')
-        self.assertEqual(self.data.data[0][0], 0.279783)
-        self.assertEqual(self.data.data[0][1], 0.28951)
-        self.assertEqual(self.data.data[0][2], 0.167634)
+        self.assertEqual(self.data.data[0], 0.279783)
+        self.assertEqual(self.data.data[1], 0.28951)
+        self.assertEqual(self.data.data[2], 0.167634)
         
 class danse_reader(unittest.TestCase):
@@ -147,11 +147,11 @@
         
         self.assertEqual(self.data.I_unit, '1/cm')
-        self.assertEqual(self.data.data[0][0], 1.57831)
-        self.assertEqual(self.data.data[0][1], 2.70983)
-        self.assertEqual(self.data.data[0][2], 3.83422)
-
-        self.assertEqual(self.data.err_data[0][0], 1.37607)
-        self.assertEqual(self.data.err_data[0][1], 1.77569)
-        self.assertEqual(self.data.err_data[0][2], 2.06313)
+        self.assertEqual(self.data.data[0], 1.57831)
+        self.assertEqual(self.data.data[1], 2.70983)
+        self.assertEqual(self.data.data[2], 3.83422)
+
+        self.assertEqual(self.data.err_data[0], 1.37607)
+        self.assertEqual(self.data.err_data[1], 1.77569)
+        self.assertEqual(self.data.err_data[2], 2.06313)
 
  
Index: DataLoader/test/utest_averaging.py
===================================================================
--- DataLoader/test/utest_averaging.py	(revision e84e1e6874ff25d657d3c693962f6ffea1337ea6)
+++ DataLoader/test/utest_averaging.py	(revision afab469f5d1e0cc0a7cfc1b1357f0b9d2fd644b1)
@@ -3,5 +3,5 @@
 
 from DataLoader.loader import  Loader
-from DataLoader.manipulations import Ring, CircularAverage, SectorPhi, get_q
+from DataLoader.manipulations import Ring, CircularAverage, SectorPhi, get_q,reader2D_converter
  
 import os.path
@@ -20,19 +20,38 @@
         x_0  = numpy.ones([100,100])
         dx_0 = numpy.ones([100,100])
-        self.data = data_info.Data2D(x_0, dx_0)
+        
+        self.data = data_info.Data2D(data=x_0, err_data=dx_0)
         detector = data_info.Detector()
-        detector.distance = 1000.0
-        detector.pixel_size.x = 1.0
-        detector.pixel_size.y = 1.0
-        detector.beam_center.x = 50
-        detector.beam_center.y = 50
+        detector.distance = 1000.0  #mm
+        detector.pixel_size.x = 1.0 #mm
+        detector.pixel_size.y = 1.0 #mm
+        
+        # center in pixel position = (len(x_0)-1)/2
+        detector.beam_center.x = (len(x_0)-1)/2 #pixel number
+        detector.beam_center.y = (len(x_0)-1)/2 #pixel number
         self.data.detector.append(detector)
         
         source = data_info.Source()
-        source.wavelength = 10.0
+        source.wavelength = 10.0 #A
         self.data.source = source
         
-        self.qmin = get_q(1.0, 1.0, 1000.0, 10.0)
-        
+        # get_q(dx, dy, det_dist, wavelength) where units are mm,mm,mm,and A respectively.
+        self.qmin = get_q(1.0, 1.0, detector.distance, source.wavelength)
+
+        self.qmax = get_q(49.5, 49.5, detector.distance, source.wavelength)
+        
+        self.qstep = len(x_0)
+        x=  numpy.linspace(start= -1*self.qmax,
+                               stop= self.qmax,
+                               num= self.qstep,
+                               endpoint=True )  
+        y = numpy.linspace(start= -1*self.qmax,
+                               stop= self.qmax,
+                               num= self.qstep,
+                               endpoint=True )
+        self.data.x_bins=x
+        self.data.y_bins=y
+        self.data = reader2D_converter(self.data)
+            
     def test_ring_flat_distribution(self):
         """
